/*
 *  Copyright 2015 Anyware Services
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */

Ext.namespace('org.ametys.survey.control');

org.ametys.survey.control.OpenSurveyActionButton = function(id, configuration, pluginName)
{
	org.ametys.survey.control.OpenSurveyActionButton.superclass.constructor.call(this, id, configuration, pluginName);
}

Ext.extend(org.ametys.survey.control.OpenSurveyActionButton, org.ametys.ribbon.control.button.ActionSelectionButton, {});

org.ametys.survey.control.OpenSurveyActionButton.prototype.onMessage = function(messages)
{
	for (var i=0; i < messages.length; i++)
    {
        if (messages[i].getType().getName() == org.ametys.ribbon.RibbonManager.EVENTTYPE_SELECTIONCHANGED)
        {
            var targets = messages[i].getTargets();
            var target = org.ametys.messagebus.message.MessageTargetHelper.findFirst(targets, this._testTarget.createDelegate(this));
            
            if (target != null)
            {
                var toolOpened = org.ametys.uitool.ToolsManager.getInstance().getTool ("survey-preview-" + target.getParameters().id) != null;
                this.getElements().each(function(element) { element.setDisabled(!toolOpened); })
                if (!toolOpened)
                {
                    var text = this._getTooltip(this.getConfiguration()["not-open-description"]);
                    this.updateTooltip(text, null, null);
                }
                else
                {
                    this.updateTooltip(this.getConfiguration()["default-description"], null, null);
                }
                
            }
            else
            {
                var text = this._getTooltip(this.getConfiguration()["no-selection-description"]);
                this.updateTooltip(text, null, null);
                this.getElements().each(function(element) { element.disable(); })
            }
        }
    }
}

org.ametys.survey.control.OpenSurveyActionButton.prototype._getTooltip = function (addedText)
{
    var tooltip = this.getConfiguration()["default-description"];
    if (addedText != null && addedText.length > 0)
    {
        tooltip += "<br/><br/>";
        tooltip += addedText;
    }
    return tooltip;
}
